// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from autoware_auto_msgs:msg/VehicleKinematicState.idl
// generated code does not contain a copyright notice

#ifndef AUTOWARE_AUTO_MSGS__MSG__DETAIL__VEHICLE_KINEMATIC_STATE__STRUCT_HPP_
#define AUTOWARE_AUTO_MSGS__MSG__DETAIL__VEHICLE_KINEMATIC_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'state'
#include "autoware_auto_msgs/msg/detail/trajectory_point__struct.hpp"
// Member 'delta'
#include "geometry_msgs/msg/detail/transform__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__autoware_auto_msgs__msg__VehicleKinematicState __attribute__((deprecated))
#else
# define DEPRECATED__autoware_auto_msgs__msg__VehicleKinematicState __declspec(deprecated)
#endif

namespace autoware_auto_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VehicleKinematicState_
{
  using Type = VehicleKinematicState_<ContainerAllocator>;

  explicit VehicleKinematicState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    state(_init),
    delta(_init)
  {
    (void)_init;
  }

  explicit VehicleKinematicState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    state(_alloc, _init),
    delta(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _state_type =
    autoware_auto_msgs::msg::TrajectoryPoint_<ContainerAllocator>;
  _state_type state;
  using _delta_type =
    geometry_msgs::msg::Transform_<ContainerAllocator>;
  _delta_type delta;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__state(
    const autoware_auto_msgs::msg::TrajectoryPoint_<ContainerAllocator> & _arg)
  {
    this->state = _arg;
    return *this;
  }
  Type & set__delta(
    const geometry_msgs::msg::Transform_<ContainerAllocator> & _arg)
  {
    this->delta = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator> *;
  using ConstRawPtr =
    const autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__autoware_auto_msgs__msg__VehicleKinematicState
    std::shared_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__autoware_auto_msgs__msg__VehicleKinematicState
    std::shared_ptr<autoware_auto_msgs::msg::VehicleKinematicState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VehicleKinematicState_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->state != other.state) {
      return false;
    }
    if (this->delta != other.delta) {
      return false;
    }
    return true;
  }
  bool operator!=(const VehicleKinematicState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VehicleKinematicState_

// alias to use template instance with default allocator
using VehicleKinematicState =
  autoware_auto_msgs::msg::VehicleKinematicState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace autoware_auto_msgs

#endif  // AUTOWARE_AUTO_MSGS__MSG__DETAIL__VEHICLE_KINEMATIC_STATE__STRUCT_HPP_
